// MAIN.CPP

#include <graphics.h>
#include <stdlib.h>
#include <bios.h>
#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include "music.h"

#define MAXFILES 20

char program[]="\"MUSIC AND NOTES\"  Version 1.00  ...  Programmed by Carl Banks";
song_t far* csong;

int backp, forep;

void interrupt (far* int1C)(...);
void interrupt (far* int23)(...);

void interrupt ctrlbreak(...)
{
}

void (*makesound)(unsigned)=sound;
void none(unsigned) {}

int ww;

void endsong()
{
 disable();
 resettempo();
 setvect(0x1C,int1C);
 setvect(0x23,int23);
 enable();
}

int playsong(note_t far* song)
{
note_t far* drawing;
register int c;
int s=0;
unsigned char a46c;
char nbuffer[6];
register int nbufc=0;

 disable();
 int1C=getvect(0x1C);
 int23=getvect(0x23);
 setvect(0x1C,playnote);
 setvect(0x23,ctrlbreak);
 enable();

 initsong();
 playing=drawing=song;
 playfunc=pfSTARTSONG;
stillplaying:
 if(s==0)
	{
	 while((playfunc!=pfNOSONG || drawing<=playing) && (c=bioskey(1))==0)
		if(drawing<=playing) drawnote(drawing++);
	}
 else
	{
	 while(*(char far*)0x046CL!=a46c && (c=bioskey(1))==0);	 
	}

 if(c!=0) bioskey(0);
 c&=0x00FF;
 if(c>='0' && c<='9')
	{
	 if(nbufc<6) nbuffer[nbufc++]=c;
	 goto stillplaying;
	}
 switch(c)
	{
	case '\t':
	 setpalette(0,backp=rand());
	 setpalette(1,forep=rand());
	 goto stillplaying;

	case 'b':
	case 'B':
	 nbuffer[nbufc]='\0';
	 setpalette(0,backp=atoi(nbuffer));
	 nbufc=0;
	 goto stillplaying;

	case 'c':
	case 'C':
	 setpalette(0,backp=63);
	 setpalette(1,forep=0);
	 goto stillplaying;

	case 'f':
	case 'F':
	 nbuffer[nbufc]='\0';
	 setpalette(1,forep=atoi(nbuffer));
	 nbufc=0;
	 goto stillplaying;

	case 'h':
	case 'H':
	 while(bioskey(1)==0);
	 bioskey(0);
	 goto stillplaying;

	case 'i':
	case 'I':
	 setpalette(0,forep);
	 setpalette(1,backp);
	 c=forep, forep=backp, backp=c;
	 goto stillplaying;

	case 'P':
	case 'p':
	 nosound();
	 outportb(0x21,inportb(0x21)|0x01);
	 while(bioskey(1)==0);
	 outportb(0x21,inportb(0x21)&0xFE);
	 bioskey(0);
	 goto stillplaying;

	case 's':
	case 'S':
	 if(makesound==sound) makesound=none;
	 else makesound=sound;
	 goto stillplaying;

	case '\b':
	 if(nbufc) nbufc--;
	 goto stillplaying;

	case ' ':
	 ww=-2;
	 c=0;
	 break;

	case '\r':
	 nbuffer[nbufc]='\0';
	 ww=atoi(nbuffer)-1;
	 c=0;
	 break;

	case 27:
	 c=-1;
	 break;

	case 0:
	 if(s==1)
		{
		 c=0;
		 break;
		}
	 endsong();
	 a46c=*(char far*)0x046CL+91;
	 s++;
	 goto stillplaying;
	}

 if(s==0) endsong();
 return c;
}

inline void cls()
{
 _AX=3;
 geninterrupt(0x10);
}

void main(int argc, char** argv)
{
note_t far* song;
register int i, j;
int d, m;
char* rm;
ffblk o;
union
{
void* realfilenames;
char (*filenames)[13];
};

 nosound();

 registerbgidriver(EGAVGA_driver);
 registerbgifont(triplex_font);

 cls();
 printf("%s\n\n",program);

 if(argc<=1)
	{
	 realfilenames=malloc(13*MAXFILES);

	 i=findfirst("*.MNL",&o,0);
	 for(j=0;!i&&j<MAXFILES;j++)
		{
		 strcpy(filenames[j],o.ff_name);
		 printf("%d.\t%s\n",j+1,o.ff_name);
		 i=findnext(&o);
		}

	 printf("\nWhich file? ");
	 sscanf(gets(espace),"%d",&d);
	 strcpy(espace,d>0&&d<=j?filenames[d-1]:"zap");

	 free(realfilenames);
	}
 else strcpy(espace,argv[1]);

 switch(processfile(argc>1?argv[1]:espace))
	{
	case eNONE:
songmenu:
	 cls();
	 printf("%s\n\n",program);
	 for(i=0;i<rsongs;i++) printf("%2d. %-32.32Fs    ",i+1,master[i].lines[0]);
	 printf("\n\nType \"0\" to exit, or just press Enter for random songs.\nWhich song first? ");
	 if(gets(espace)[0]=='\0') ww=-2;
	 else ww=atoi(espace)-1;
	 if(ww==-1) goto abort_song;

	 d=VGA, m=VGAHI;
	 initgraph(&d,&m,"");
	 setpalette(0,backp=63);
	 setpalette(1,forep=0);
	 cleardevice();

	 setcolor(1);
	 setfillstyle(SOLID_FILL,1);

	 srand(*(unsigned far*)0x046CUL);
	 do
		{
		 do
			csong=&master[(ww>=0?ww++:rand())%rsongs],
			song=csong->music;
		 while(song==0L);
		}
	 while(playsong(song)!=-1);
	 nosound();
	 closegraph();
	 goto songmenu;

abort_song:
	 freefile();
	 cls();
	 rm="Gee, it's too bad we have to end on this note.\n"
		"Ha Ha Ha!";
	 break;

	case eFILENOTFOUND:
	 rm="Whoa! That Song Library doesn't exist!";
	 break;

	case eOUTOFMEM:
	 rm="Whoa! We're out of memory!";
	 break;

	case eSYNTAX:
	 rm="Whoa! None of the songs worked!";
	 break;

	case eEOF:
	 rm="Whoa! There's no songs in this file!";
	 break;
	}

 printf("%s\n\n%s\n\n",program,rm);
}
