// MUSIC.CPP

#include "music.h"

#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <bios.h>
#include <mem.h>
#include <string.h>
#include <dos.h>

FILE* fp;

char espace[100];

note_t huge* nspace;

int isongs, rsongs;
song_t far* master;
void far* start, huge* end, huge* go;

int addnote(register unsigned char name, register unsigned char dur)
{                      
 nspace->_dur=dur;
 ((note_t far*)nspace)->_name=name;
 return (++nspace)>=end;
}

int compilefield()
{
int ft;
int a, b;
register int c, i;

 if(feof(fp)) return eEOF;
 ft=toupper(fgetc(fp));
 i=0;
 do
	{
	 if(feof(fp)) return eEOF;
	 c=espace[i++]=toupper(fgetc(fp));
	}
 while(c!='%');
 espace[i-1]='\0';

 switch(ft)
	{
	case ':':
	 sscanf(espace,"%d/ %d",&a,&b);
	 if(a==0 || (b!=2 && b!=4 && b!=8)) return eOUTOFRANGE;
	 if(addnote((a<<4)|(b&0x0f),ccSETTIME)) return eOUTOFMEM;
	 break;

	case '#':
	 if((i=toupper(espace[1]))<'A' || i>'G') return eSYNTAX;
	 c=i-'A';
	 switch(espace[0])
		{
		case '-': c|=nnFLAT; break;
		case '#':
		case '+': c|=nnSHARP; break;
		case '=': c|=nnNATURAL; break;
		default: return eSYNTAX;
		}
	 if(addnote(c,ccSETSHARPFLAT)) return eOUTOFMEM;
	 break;

	case 'T':
	 sscanf(espace,"%d",&i);
	 if(i<60 || i>360) return eOUTOFRANGE;
	 else if(addnote(i/2,ccSETTEMPO)) return eOUTOFMEM;
	 break;

	default:
	 return eSYNTAX;
	}

 return 0;
}

int compile()
{
int dlen=quarter, doct=4, dpor=0;
register int len=dlen;
int oct=doct, por=dpor, sf=0;
int hlen, ecounter=0;

register int c;

 do
	{
	 if(feof(fp)) return eEOF;
	 c=toupper(getc(fp));
	 if(c>='A' && c<='G')
		{
		 if(addnote(((c>='C'?oct-1:oct)*8+c-'A')|sf,len|por))
			return eOUTOFMEM;
		 if(ecounter) len=hlen, ecounter--;
		 else len=dlen;
		 oct=doct, por=dpor, sf=0;
		}
	 else switch(c)
		{
		case 'L':
		 dlen=len;
		 break;

		case 'R':
		 if(addnote(REST,len)) return eOUTOFMEM;
		 len=dlen, oct=doct, por=dpor, sf=0;
		 break;

		case 'T':
		 hlen=twelfth;
		 len=firsttwelfth;
		 ecounter=2;
		 break;

		case 'U':
		 hlen=sixth;
		 len=firstsixth;
		 ecounter=2;
		 break;

		case 'W':
		 hlen=twelfth;
		 len=sixth;
		 ecounter=1;
		 break;

		case '1':
		 len=whole;
		 break;

		case '2':
		 len=half;
		 break;

		case '4':
		 len=quarter;
		 break;

		case '8':
		 len=eighth;
		 break;

		case '6':
		 len=sixteenth;
		 break;

		case '3':
		 len=thirtysecond;
		 break;

		case '.':
		 if(len!=thirtysecond) len+=subtractdot;
		 break;

		case '!':
		 if(!(por&nnTIE)) por|=nnSTACCATO;
		 break;

		case '_':
		 por|=nnLEGATO;
		 break;

		case '(':
		 por=(dpor|=nnTIE);
		 break;

		case ')':
		 por=(dpor&=(~nnTIE));
		 break;

		case '+':
		case '#':
		 sf|=nnSHARP;
		 break;

		case '-':
		 sf|=nnFLAT;
		 break;

		case '=':
		 sf|=nnNATURAL;
		 break;

		case '*':
		 oct++;
		 break;

		case '/':
		 oct--;
		 break;

		case '>':
		 oct=--doct;
		 break;

		case '<':
		 oct=++doct;
		 break;

		case '^':
		 if(addnote(cfFERMATA,ccFUNCTION)) return eOUTOFMEM;
		 break;

		case '|':
		 if(addnote(cfENDOFMEASURE,ccFUNCTION)) return eOUTOFMEM;
		 break;

		case '`':
		 if(addnote(cfRUNBREAK,ccFUNCTION)) return eOUTOFMEM;
		 break;

		case '%':
		 if((c=compilefield())!=0) return c;
		 break;

		case ' ':
		case '\r':
		case '\n':
		case '\t':
		case '}':
		 break;

		default:
		 return eCHAR;
		}
	}
 while(c!='}');

 if(addnote(cfENDOFSONG,ccFUNCTION)) return eOUTOFMEM;

 return eNONE;
}

int processfile(char* filename)
{
unsigned long fcl;
register int c, i;
int lc;

 if((fp=fopen(filename,"r"))==NULL) return eFILENOTFOUND;
 go=start=(char far*)farmalloc((fcl=farcoreleft())-256);
 end=(char huge*)go+fcl;
 if(start==NULL) { fclose(fp); return eOUTOFMEM; } // ?

 sscanf(fgets(espace,10,fp),"%d",&isongs);
 master=(song_t huge*)go;
 (song_t huge*)go+=isongs;
 if(go>=end) { fclose(fp); farfree(start); return eOUTOFMEM; }

 for(rsongs=0;rsongs<isongs;rsongs++)
	{
	 lc=0;
	 for(i=0;i<4;i++) master[rsongs].lines[i]=0L;

nextchar:
	 switch(c=fgetc(fp))
		{
		case '{':
		 nspace=(note_t huge*)go;
		 switch(i=compile())
			{
			case eNONE:
			 master[rsongs].music=(note_t huge*)go;
			 go=nspace;
			 break;

			case eOUTOFMEM:
			 goto breakmem;
 
			default:
			 fseek(fp,-4L,SEEK_CUR);
			 fread(espace,8,1,fp);
			 espace[8]='\0';
			 printf("Something wrong\nSong: %Fs\nError: %d\n--------\n%s",
				master[rsongs].lines[0],i,espace);
			 bioskey(0);
			 master[rsongs].music=0L;
			}
		 break;

		case -1:
		 goto breakok;

		case '\n':
		case '\t':
		case '\r':
		case ' ':
		 goto nextchar;

		case ';':
		 fgets(espace,sizeof(espace),fp);
		 goto nextchar;
		
		case '$':
		 strcpy(espace,"Music by ");
		 fgets(espace+9,sizeof(espace),fp);
		 goto copyline;

		case '#':
		 strcpy(espace,"Lyrics by ");
		 fgets(espace+10,sizeof(espace),fp);
		 goto copyline;

		case '@':
		 strcpy(espace,"Music and Lyrics by ");
		 fgets(espace+20,sizeof(espace),fp);
		 goto copyline;

		default:
		 espace[0]=c;
		 fgets(espace+1,sizeof(espace),fp);
copyline:	 if(lc==4) goto nextchar;
		 espace[(i=strlen(espace))-1]='\0';
		 if((char huge*)go+i>=end) goto breakmem;
		 movedata(FP_SEG(espace),FP_OFF(espace),FP_SEG(go),
			FP_OFF(go),i);
		 master[rsongs].lines[lc++]=(char huge*)go;
		 (char huge*)go+=i;
		 goto nextchar;
		}
	 continue;

breakmem:
	 printf("Ran out of memory\nSong: %Fs\n",
		master[rsongs].lines[0]);
	 bioskey(0);
breakok:
	 break;
	}
 fclose(fp);

 if(rsongs==0) return eEOF;
 for(i=0;i<rsongs;i++) if(master[c].music!=0L) break;
 if(i==rsongs)
	{
	 farfree(start);
	 return eSYNTAX;
	}
 return eNONE;
}

void freefile()
{
 farfree(start);
}
