// MUSIC.H

#define REST 7

#define LITTLETICKS 71582788UL

enum note_durations
{
thirtysecond,
sixteenth,
eighth,
quarter,
half,
whole,

dottedsixteenth,
dottedeighth,
dottedquarter,
dottedhalf,
dottedwhole,

twelfth,
sixth,
firsttwelfth,
firstsixth,

ALLNOTETYPES,
NOTETYPES=dottedwhole+1,

subtractdot=dottedsixteenth-sixteenth
};

inline int isdotted(int j) { return j>=dottedsixteenth && j<=dottedwhole; }

enum player_functions
{
pfNOSONG,
pfSTARTSONG,
pfSTARTSOUND,
pfSOUND,
pfSTARTREST,
pfREST
};

enum control_codes
{
ccFUNCTION=0xFF,
ccSETSHARPFLAT=0xFE,
ccSETTEMPO=0xFD,
ccSETTIME=0xFC,
};

enum control_functions
{
cfENDOFSONG,
cfENDOFMEASURE,
cfRUNBREAK,
cfFERMATA,
};

enum
{
nnCONTROL=0xC0,
nnSTACCATO=0x80,
nnLEGATO=0x40,

nnTIE=0x20,

nnDURATION=0x0F,

nnACCIDENTAL=0xC0,
nnNATURAL=0xC0,
nnSHARP=0x80,
nnFLAT=0x40,
nnOCTAVE=0x38,
nnNAME=0x07,
nnNAMEOCT=0x3F,
};

enum
{
eNONE,
eFILENOTFOUND,
eOUTOFMEM,
eEOF,
eCHAR,
eSYNTAX,
eOUTOFRANGE,
};

/* RESERVED BITS IN NOTE TYPE:

_dur:	S L T - D D D D
_name:	H H O O O N N N

*/

struct note_t
{
	unsigned char _dur, _name;
};

struct song_t
{
	note_t far* music;
	char far* lines[4];
};

// DRAW.CPP
void drawnote(note_t far* n);
void initsong();

extern signed char numtable[];

// SOUND.CPP
void settempo(int bpm), resettempo();

void interrupt playnote(...);

extern note_t far* playing;
extern int playfunc;
extern signed char songaccs[7];

extern char nametable[];

extern int fullnotedurs[][ALLNOTETYPES],
	regnotedurs[][ALLNOTETYPES],
	stacnotedurs[][ALLNOTETYPES];
extern int* fullnotedur, * regnotedur, * stacnotedur;

// MUSIC.CPP
int processfile(char* filename);
void freefile();

extern int isongs, rsongs;
extern song_t far* master;

extern char espace[];

// MAIN.CPP

extern void (*makesound)(unsigned);
extern song_t far* csong;
extern char program[];