// SOUND.CPP

#include <dos.h>
#include "music.h"

//      32 16  8  4   2   1.16 .8 .4  .2  .1    12 6
int fullnotedurs[][ALLNOTETYPES]={
	{2, 4, 8,16, 32, 64, 6,12,24, 48, 96,	 5,11,	 6,10},
	{4, 8,16,32, 64,128,12,24,48, 96,192,	11,21,	10,22},
	{8,16,32,64,128,256,24,48,96,192,384,	21,43,	22,42}
	};
int regnotedurs[][ALLNOTETYPES]={
	{1, 3, 7,14, 28, 60, 5,10,21, 44, 92,	 4, 9,	 5, 8},
	{3, 7,14,28, 60,124,10,21,44, 92,188,	 9,18,	 9,18},
	{7,14,28,60,124,252,21,44,92,188,380,	18,39,	18,38}
	};
int stacnotedurs[][ALLNOTETYPES]={
	{1, 3, 6,12, 24, 56, 4, 9,18, 40, 88,	 3, 7,	 4, 7},
	{3, 6,12,24, 56,120, 9,18,40, 88,184,	 7,15,	 7,16},
	{6,12,24,56,120,248,18,40,88,184,376,	15,35,	16,34}
	};

int* fullnotedur=fullnotedurs[1];
int* regnotedur=regnotedurs[1];
int* stacnotedur=stacnotedurs[1];

unsigned freqtable[]={
/*
A	A#	B	C	C#	D
D#	E	F	F#	G	G#
*/
55,	58,	61,	65,	69,	73,
77,	82,	87,	92,	98,	104,

110,	117,	124,	131,	140,	147,
156,	165,	175,	185,	196,	208,

220,	233,	247,	262,	277,	294,
312,	330,	349,	370,	392,	415,

440,	466,	494,	523,	554,	587,
622,	659,	698,	740,	784,	831,

880,	932,	988,	1047,	1109,	1175,
1245,	1319,	1397,	1480,	1568,	1661,

1760,	1865,	1976,	2093,	2217,	2349,
2489,	2637,	2794,	2960,	3136,	3322,

3520,	3729,	3951,	4186,	4435,	4699,
4978,	5274,	5588,	5920,	6272,	6645,

7040,	7459,	7902,	8372,	8870,	9397,
9956,	10548,	11175,	11840,	12544,	13290,

14080};

char nametable[]={
0,2,3,5,7,8,10,0,
12,14,15,17,19,20,22,0,
24,26,27,29,31,32,34,0,
36,38,39,41,43,44,46,0,
48,50,51,53,55,56,58,0,
60,62,63,65,67,68,70,0,
72,74,75,77,79,80,82,0,
84,86,87,89,91,92,94,0,
96,98,99,101,103,104,106,0
};

signed char songaccs[7];

note_t far* playing;
int playfunc=pfNOSONG;

int playcount, restcount, freq;

void settempo(register int bpm)
{
unsigned long t;

 t=(LITTLETICKS/32)/bpm;
 outportb(0x43,0x36);
 outportb(0x40,*(char*)&t);
 outportb(0x40,*(((char*)&t)+1));
}

void resettempo()
{
 outportb(0x43,0x36);
 outportb(0x40,0);
 outportb(0x40,0);
}

void nextnote(void)
{
int i;
register unsigned char dur, name;
int fermata=0;

lookagain:
 dur=playing->_dur;
 name=playing->_name;
 if(dur>=nnCONTROL) switch(dur)
	{
	case ccFUNCTION:
	 switch(name)
		{
		case cfENDOFSONG:
		 playfunc=pfNOSONG;
		 return;

		case cfFERMATA:
		 fermata=1;
		 playing++;
		 goto lookagain;

		default:
		 playing++;
		 goto lookagain;
		}

	case ccSETSHARPFLAT:
	 switch(name&nnACCIDENTAL)
		{
		case nnFLAT: i=-1; break;
		case nnSHARP: i=1; break;
		case nnNATURAL: i=0; break;
		}
	 songaccs[name&nnNAME]=i;
	 playing++;
	 goto lookagain;

	case ccSETTIME:
	 switch(name&0x0F)
		{
		case 2:
		 fullnotedur=fullnotedurs[0];
		 regnotedur=regnotedurs[0];
		 stacnotedur=stacnotedurs[0];
		 break;

		case 4:
		 fullnotedur=fullnotedurs[1];
		 regnotedur=regnotedurs[1];
		 stacnotedur=stacnotedurs[1];
		 break;

		case 8:
		 fullnotedur=fullnotedurs[2];
		 regnotedur=regnotedurs[2];
		 stacnotedur=stacnotedurs[2];
		 break;
		}
	 playing++;
	 goto lookagain;

	case ccSETTEMPO:
	 settempo(name*2);
	 playing++;
	 goto lookagain;
	 
	default:
	 playing++;
	 goto lookagain;
	}

 if(name==REST)
	{
	 restcount=fullnotedur[dur&nnDURATION];
	 playfunc=pfSTARTREST;
	}
 else
	{
	 i=nametable[name&nnNAMEOCT];
	 switch(name&nnACCIDENTAL)
		{
		case nnSHARP: i++; break;
		case nnFLAT: i--; break;
		case 0: i+=songaccs[name&nnNAME]; break;
		}
	 freq=freqtable[i];

	 if(dur&(nnLEGATO|nnTIE)) playcount=fullnotedur[dur&nnDURATION];
	 else if(dur&nnSTACCATO) playcount=stacnotedur[dur&nnDURATION];
	 else playcount=regnotedur[dur&nnDURATION];

	 restcount=fullnotedur[dur&nnDURATION]-playcount;
	 playfunc=pfSTARTSOUND;
	}

 if(fermata) playcount*=2, restcount*=3;
}

void interrupt playnote(...)
{
 disable();
 switch(playfunc)
	{
	case pfSTARTSONG:
	 ((int*)songaccs)[0]=0;
	 ((int*)songaccs)[1]=0;
	 ((int*)songaccs)[2]=0;
	 songaccs[6]=0;
	 nextnote();
	 break;

	case pfSTARTSOUND:
	 (*makesound)(freq);
	 playfunc=pfSOUND;
	 
	case pfSOUND:
	 playcount--;
	 if(playcount==0)
		{
		 if(restcount==0) playing++, nextnote();
		 else playfunc=pfSTARTREST;
		}
	 break;

	case pfSTARTREST:
	 nosound();
	 playfunc=pfREST;

	case pfREST:
	 restcount--;
	 if(restcount==0) playing++, nextnote();
	 break;
	}
 enable();
}
